/* fBNg֌W̃R}h̒`\[X */
#include <ctype.h>
#include <stdlib.h>
#include "ntcons.h"
#include "nndir.h"
#include "shell.h"

NnVector dirstack;
static NnString  prevdir , currdir ;

/* X^bN̓e ~n ɔf */
static void chg_tilde()
{
    int i;
    for( i=1 ; i <= 9 ; ++i ){
	char no[]={ '0' + i , '\0' };
	int n=dirstack.size()-i;
	if( n >= 0 ){
	    NnDir::specialFolder.put( no , ((NnString*)dirstack.at(n))->clone() );
	}else{
	    NnDir::specialFolder.remove( no );
	}
    }
}

/* chdir ̃bp[. ÕfBNgL.
 *	dir - ړfBNg
 * return
 *	0 -  , not 0 - s
 */
static int chdir_( const NnString &dir )
{
    int rc;
    if( currdir.empty() ){
        NnDir::getcwd( currdir );
    }
    
    if( (rc=NnDir::chdir( dir.chars() )) == 0 ){
        prevdir = currdir;
        NnString title("NYAOS - ");
        NnDir::getcwd( currdir );
        title << currdir ;
	Console::setConsoleTitle( title.chars() );
    }
    return rc;
}

/* JgfBNgX^bN */
static void pushd_here()
{
    NnString *cwd=new NnString();
    NnDir::getcwd(*cwd);
    dirstack.append( cwd );
}

/* X^bNgbvJgfBNg 
 *    return 
 *	NULL:  
 *      not NULL: s̃fBNg
 *          (ĂяoɂāAdelete 邱)
 */
static NnString *popd_here()
{
    NnString *cwd = (NnString*)dirstack.shift();
    if( chdir_( *cwd ) != 0 ){
	return cwd;
    }else{
	delete cwd;
	return NULL;
    }
}

/* X^bNgbvƃJgfBNg
 * return
 *	NULL - 
 *	not NULL - ړłȂꍇ̃X^bNgbv
 */
static NnString *swap_here()
{
    NnString *top=(NnString*)dirstack.top();
    NnString newcwd( *top );
    NnDir::getcwd( *top );

    if( chdir_( newcwd ) != 0 ){
	delete (NnString*)dirstack.shift();
	return new NnString(newcwd);
    }
    return NULL;
}

/* R}h dirs */
int cmd_dirs( NyadosShell &shell , const NnString & )
{
    NnString cwd;

    NnDir::getcwd(cwd);
    conOut << cwd ;
    for(int i=dirstack.size()-1 ; i>=0 ; i-- ){
        conOut << ' ' << *(NnString*)dirstack.at(i);
    }
    conOut << '\n';
    return 0;
}

/* R}h pushd */
int cmd_pushd( NyadosShell &shell , const NnString &argv_ )
{
    NnString argv(argv_);
    int here_flag = 0;
    if( argv.startsWith("-") ){
        NnString arg1,left;

        argv.splitTo( arg1,left);
        argv = left;
        if( arg1.compare("-h")==0 ){
            here_flag = 1;
        }else if( arg1.compare("-H")==0 ){
            here_flag = 2;
        }
    }

    if( argv.empty() ){
        /* X^bNgbṽfBNgƃJgfBNgւ */
        if( dirstack.size() < 1 ){
            if( here_flag ){
                pushd_here();
            }else{
                conErr << "pushd: directory stack empty.\n";
                return 0;
            }
        }else{
            if( here_flag == 2 ){
                pushd_here();
            }else{
		NnString *dir=swap_here();
                if( dir != NULL ){
		    conErr << "pushd: stack top `" << *dir << "' not found.\n";
		    delete dir;
		    return 0;
		}
            }
        }
    }else if( argv.at(0) == '+' && isDigit(argv.at(1)) ){
        /* X^bN +n `Ŏw肷Bn ] */
        int n=atoi(argv.chars()+1);
        if( n > 0 ){
            /* ɃJgfBNg push _ŁA
             * łɈ] 
             */
            pushd_here();
            while( --n > 0 )
                dirstack.append( dirstack.shift() );
	    NnString *faildir=popd_here();
	    if( faildir != NULL ){
		conErr << "pushd: directory `" << *faildir << "' not found.\n";
		delete faildir;
		return 0;
	    }
        }
    }else{
        /* ݂̃fBNgX^bNɕۑ */
        pushd_here();
        /* fBNgړ */
        NyadosShell::dequote( argv );
	if( chdir_( argv ) != 0 ){
	    conErr << argv << ": no such directory.\n";
	    delete popd_here();
	    return 0;
	}
    }
    chg_tilde();
    return cmd_dirs(shell,argv);
}

/* R}h popd [`  */
int cmd_popd( NyadosShell &shell , const NnString &argv )
{
    if( dirstack.size() <= 0 ){
        conErr << "popd: dir stack is empty.\n";
        return 0;
    }
    if( argv.at(0) == '+' && isDigit(argv.at(1)) ){
        NnString *dir=(NnString*)dirstack.at(atoi(argv.chars()+1));
        if( dir == NULL ){
            conErr << "popd: " << argv << ": bad directory stack index\n";
            return 0;
        }else{
	    if( chdir_( *dir ) != 0 ){
		conErr << "popd: " << *dir << ": not found.\n";
		return 0;
	    }
        }
    }else{
        NnString *dir=(NnString*)dirstack.pop();
	chg_tilde();
	if( chdir_( *dir ) != 0 ){
	    conErr << "popd: " << *dir << ": not found.\n";
	    delete dir;
	    return 0;
	}
        delete dir;
    }
    return cmd_dirs(shell,argv);
}

int cmd_shift( NyadosShell &shell , const NnString & )
{
    shell.shift();
    return 0;
}

int cmd_goto( NyadosShell &shell , const NnString &argv )
{
    NnString label( argv );
    label.trim();
    shell.goLabel(label);
    return 0;
}

int cmd_pwd( NyadosShell &shell , const NnString & )
{
    NnString pwd;
    if( NnDir::getcwd( pwd ) == 0 ){
        conOut << pwd << '\n';
    }else{
        conErr << "can't get current working directory.\n";
    }
    return 0;
}


/* R}h chdir [` */
int cmd_chdir( NyadosShell &shell , const NnString &argv )
{
    int basedir=0;
    NnString newdir;
    if( argv.empty() ){
	 /* ̏ꍇ */
	if( getEnv("HOME") == NULL &&
            getEnv("USERPROFILE") == NULL )
	    return cmd_pwd(shell,argv);
	newdir = "~";
    }else if( argv.startsWith("-") ){
	/* IvV */
	NnString tmp , opt;

	argv.splitTo( opt , tmp );
	if( opt.icompare("--basedir") == 0 ){
	    basedir = 1;
        }else if( opt.compare("-") == 0 ){
            if( prevdir.empty() ){
                conErr << opt << ": can not chdir.\n";
                return 0;
            }
            tmp = prevdir;
	}else{
	    conErr << opt << ": no such option.\n";
	    return 0;
	}
	NyadosShell::dequote( tmp.chars() , newdir );
    }else{
	NyadosShell::dequote( argv.chars() , newdir );
    }
    
    /* chdir  */
    if( chdir_( newdir ) == 0 )
        return 0;
    
    /* chdir ̂sꍇA--basedir IvVŏꍇ */
    if( basedir ){
        int lastroot=NnDir::lastRoot( newdir.chars() );
        if( lastroot != -1 ){
            NnString bdir( newdir.chars() , lastroot );
            bdir << "\\."; // rootfBNg΍
            if( chdir_( bdir ) == 0 )
                return 0;
        }
    }
    /* G[I */
    conErr << newdir << ": no such file or directory.\n";
    return 0;
}
