#include <ctype.h>
#include <string.h>
#include <stdlib.h>

#include "nnhash.h"

/* ėpɎgAvpeB[NX */
NnHash properties;

/* Pair - nbVe[u̗vf : L[ƒl̃yAɊւNX */
NnHash::Pair::~Pair()
{
    delete value_;
}

inline void NnHash::Pair::replace( NnObject *val )
{
    if( value_ != val )
        delete value_;
    value_ = val;
}
inline NnHash::Pair *NnHash::Pair::connect( NnHash::Pair *ele )
{
    Pair *rv=next_;
    next_ = ele;
    return rv;
}

/* HashTable 
 * return
 *	0 ... 
 *     -1 ... s
 */
int NnHash::init()
{
    if( table == NULL ){
        if( (table=new Pair*[size]) == NULL )
            return -1;
        for(int i=0;i<size;i++)
            table[i] = NULL;
    }
    return 0;
}

/* NnHash::put
 *	key ̒lƂ rep o^B
 *	key == 0 ̎A폜B
 * return
 *       0 : 
 *      -1 : G[(e[uŜ̊mۂ̎s)
 *      -2 : mۃG[(vfP)
 */
int NnHash::put_(const NnString &key, NnObject *obj)
{
    if( init() ) return -1;

    int index=key.hashValue() % size;

    if( table[index] == NULL ){
        if( obj != NULL && (table[index]=new Pair(key,obj))==NULL )
            return -2;
        return 0;
    }
    Pair *cur=table[index];
    Pair **pre=&table[index];
    for(;;){
        if( cur->key().compare(key)==0 ){
            /* L[I */
            if( obj != NULL ){
                /* lNULL̏ꍇAvfu */
                cur->replace( obj );
            }else{
                /* l NULL ̏ꍇAvf̍폜 */
                *pre = cur->next();
                delete cur;
            }
            return 0;
        }
        if( cur->next() == NULL ){
            /* VKIuWFNg */
            if( obj != NULL ){
                Pair *t=new Pair(key,obj);
                if( t == NULL )
                    return -2;
                cur->connect( t );
            }
            return 0;
        }
        pre = &cur->next_;
        cur = cur->next();
    }
}

NnObject *NnHash::get(const char *key)
{
    if( table == NULL ) return NULL;
    int index=NnString::hashValue(key) % size;

    for(Pair *ptr=table[index] ; ptr != NULL ; ptr=ptr->next() ){
        if( ptr->key().compare(key)==0 )
            return ptr->value();
    }
    return NULL;
}


/* AzzB
 *	key L[l 
 * return
 *	NULL c IuWFNgւ̃|C^
 *	NULL   c }b`IuWFNg͖B
 */
NnObject *NnHash::get(const NnString &key)
{
    if( table == NULL ) return NULL;
    int index=key.hashValue() % size;
  
    for(Pair *ptr=table[index] ; ptr != NULL ; ptr=ptr->next() ){
        if( ptr->key().compare(key)==0 )
            return ptr->value();
    }
    return NULL;
}

/* fXgN^
 */
NnHash::~NnHash()
{
    if( table == NULL )
	return;

    for(int i=0;i<size;i++){
	Pair *p=table[i];
	while( p != NULL ){
	    Pair *nxt=p->next();
            delete p;
	    p = nxt;
	}
    }
#ifdef ARRAY_DELETE_NEED_SIZE
    delete[size]table;
#else
    delete[]table;
#endif
}

/* nbVpJ[\
 *	hash - nbV
 */
NnHash::Each::Each(const NnHash &h) : hash(h)
{
    if( hash.table != NULL ){
        index=-1;
        nextindex();
    }else{
        index = 0;
        ptr = NULL;
    }
}

/* zɑ΂CfbNXi߂.
 * ̃CfbNX͓ǂݔ΂.
 */
void NnHash::Each::nextindex()
{
    while( ++index < hash.size ){
        if( hash.table[index] != NULL ){
            ptr  = hash.table[index];
            return;
        }
    }
    ptr = NULL;
    index = 0;
}

/* nbVpJ[\i߂. */
void NnHash::Each::operator ++ ()
{
    if( ptr == NULL )
        return;

    if( ptr->next() != NULL ){
        ptr = ptr->next();
        return;
    }
    nextindex();
}

NnObject *NnHash::Each::operator *()
{
    return ptr;
}

NnHash::NnHash( const NnHash &o )
{
    table = 0; size = o.size;
    for( NnHash::Each p(o) ; p.more() ; ++p ){
	this->put( p->key() , p->value()->clone() );
    }
}

/* ϐ̒l𓾂(ϐ̑啶/ʂȂ)
 *    var - ϐ
 *    none - ϐ݂ȂɕԂl.
 * return
 *     ϐ̒l
 */
const char *getEnv( const char *var , const char *none )
{
    if( var == NULL || var[0] == '\0' )
	return NULL;
    const char *value=getenv(var);
    if( value != NULL  && value[0] != '\0' )
	return value;

    NnString var1(var);
    var1.upcase();
    
    return (value=getenv(var1.chars())) != NULL  &&  value[0] != '\0'
            ? value : none ;
}
