#ifndef NSTRING_H
#define NSTRING_H

#include <ctype.h>
#include <string.h>
#include "nnobject.h"

class NnVector;

/* letter_t :
 *    8bit = {0,-1} :  8bit(8bit̂ݗL)
 *               ̑ : 16bit(SbitL)
 */
typedef unsigned short letter_t;

/** NnString :
 *  ERpNgw̕IuWFNgB
 *
 *  Et@XJEeBOŁACX^XɂĂA
 *    ꕶLĂB
 *
 *  EꎞIuWFNg̈ʓ|ȓ񍀉Zq(+)͗pӂĂȂB
 *    ɁAZq(+=)A}Zq(<<)gp邱ƂłB
 *    (JavaStringBufferɋ߂)
 *
 *  Econst char* ւ̕ΐAI chars() \bhgčsB
 *    LXgZq̑d`͍sĂȂB
 *
 *  ENnHash ̃L[Ƃėp邱ƂłB̃NXB
 */
class NnString : public NnSortable { 
    struct Rep {
	int refcnt;
	int length;
	int max;
	char  buffer[1];
    };
    static Rep zero;
    enum{ INCSIZ = 16 };
    Rep *rep;
    int set( const char *s );
    int set( const char *s , int size);
    static void reset(Rep *&r);
    int independ(void);
    int keep( int len ); 
    int grow( int len ); 

    static int f2b_(int ch);
    static int b2f_(int ch);
    static int deq_(int ch);
public:
    virtual ~NnString();
    /** IuWFNg object ƔrA召֌W𕉁EE̐lŕԂ */
    virtual int compare( const NnSortable &object ) const;
    const char *repr() const { return this->chars(); }

    /** ŏ */
    NnString() : rep(&zero) {}
    /**  s ŏ */
    NnString( const char *s ){ set(s); }
    /** |C^ s  size oCg̃oCgŏ */
    NnString( const char *s , int size ){ set(s,size); }
    /**  ns ŏ */
    NnString( const NnString &ns );

    // Zq.
    /** |C^ s  size oCg̃oCg */
    int assign( const char *s , int size );
    /**  ns  */
    NnString &operator = ( const NnString &ns );
    /**  x  */
    NnString &operator = ( const char *x );
    /**  c  */
    NnString &operator = ( char c ){ assign( &c , 1 ); return *this; }

    NnString &insertAt( int at , const char *s , int siz);
    NnString &insertAt( int at , const char *s )
	{ return insertAt(at,s,strlen(s) ); }
    NnString &insertAt( int at , const NnString &ns )
	{ return insertAt(at,ns.chars(),ns.length() ); }

    /**  c 𖖔ɒǉ */
    NnString &operator += ( char c );
    /**  s 𖖔ɒǉ */
    NnString &operator += ( const char *s )
	{ return insertAt( length(), s, strlen(s) ); }
    /**  ns 𖖔ɒǉ */
    NnString &operator += ( const NnString &ns )
	{ return insertAt( length(), ns ); }

    /**  c 𖖔ɒǉ */
    NnString &operator << ( char c ){ return *this += c ; }
    /**  s 𖖔ɒǉ */
    NnString &operator << ( const char *s ){ return *this += s; }
    /**  ns 𖖔ɒǉ */
    NnString &operator << ( const NnString &ns )
	{ return insertAt( length() , ns ); }
    /** l 10i֕ϊĖɒǉ */
    NnString &addValueOf( int x );
    
    /* P */
    NnString &operator << (letter_t s)
	{ *this += (char)(s>>8) ; return *this += (char)(s & 255); }

    // |[g֐.
    /** char*^o */
    const char *chars()  const { return rep->buffer; }
    /** 󕶎ł ^Ԃ */
    int         empty()  const { return rep->length <= 0 ; }
    /** ̒𓾂 */
    int         length() const { return rep->length; }
    /** noCgڂ̕𓾂 */
    char        at(int n) const { return rep->buffer[n]; }
    char        &operator[]( int n ) { return rep->buffer[n]; }
    /** ɂ */
    void        erase(){ reset(rep); }

    /**  s ƔrA召֌W𕉁EE̐lŕԂ */
    virtual int compare( const char *s ) const;
    /**  s ƔrA召֌W𕉁EE̐lŕԂ
     *  p啶EʂȂ */
    int icompare( const char *s ) const;
    /**  s ƔrA召֌W𕉁EE̐lŕԂ
     *  p啶EʂȂ */
    int icompare( const NnString &ns ) const;
    
    /** ̑Ő󔒂폜 */
    NnString &trim();
    /** ̂PoCg폜 */
    void chop();
    /**  len oCgɂĂ܂(؂) */
    void chop(int len);
    /** 擪̂PoCg폜 */
    void shift();
    /** 擪ɂPoCg} */
    void unshift( char ch );

    void filter( int (*func)(int) );
#ifdef __DMC__
    static int toLower(int x){ return tolower(x); }
    static int toUpper(int x){ return toupper(x); }
    void downcase(){ filter(toLower); }
    void upcase(){ filter(toUpper); }
#else
    void downcase(){ filter(tolower); }
    void upcase(){ filter(toupper); }
#endif
    void slash2yen(){ filter(f2b_); }
    void yen2slash(){ filter(b2f_); }
    void dequote(){   filter(deq_); }

    /** 󔒂ŕ */
    void splitTo( NnString &first , NnString &rest ) const ;
    int splitTo( NnString &first , NnString &rest , const char *dem , const char *quote="\"" ) const;
    int splitTo( NnVector &vec ) const;

    /** ̂P(DBCSӎ)̏ʂWrbgԂ */
    int lastchar() const;

    /** s Ŏn܂Ă ^Ԃ */
    int   startsWith( const char *s     ) const;
    int   startsWith( const NnString &s ) const;
    /** s Ŏn܂Ă΁A^ԂBp啶EʂȂ */
    int  istartsWith( const char *s     ) const;
    int  istartsWith( const NnString &s ) const;

    /** s ŏIĂ΁A^ԂB*/
    int     endsWith( const char *s     ) const;
    int     endsWith( const NnString &s ) const;
    /** s ŏIĂ΁A^ԂBp啶EʂȂB*/
    int    iendsWith( const char *s     ) const;
    int    iendsWith( const NnString &s ) const;
    /* func ŔrʁAs ŏIĂ΁A^Ԃ */
#ifdef __DMC__
    int    endsWith( const char *s , int __CLIB func(const char *,const char *) ) const;
#else
    int    endsWith( const char *s , int func(const char *,const char *) ) const;
#endif
    
    /** nbVlԂ */
    virtual unsigned hashValue() const;
    static unsigned hashValue(const char *s);
    virtual NnObject *clone() const;

    static int findOf(     const char *p,const char *dem,int startIndex=0 );
    static int findLastOf( const char *p,const char *dem,int startIndex=0 );
    int findOf( const char *dem,int startIndex=0 ) const
	{ return findOf( chars() , dem , startIndex ); }
    int findLastOf( const char *dem , int startIndex=0 ) const
	{ return findLastOf( chars() , dem , startIndex ); }
    int search( const NnString &target , int start=0 );
    void replace( const NnString &from , const NnString &to , NnString &result );
    
    /* 1ŁA𑖍|C^ */
    class Iter{
	letter_t last;
    public:
	const char *next; /* ̈ʒuw肷|C^͌JĂ܂ */

	void operator ++ (){
	    if( isKanji(*next) ){
		last = ((next[0]<<8) | (next[1] & 255));
		next += 2;
	    }else if( *next ){
		last = *next++;
	    }else{
		last = 0;
	    }
	}
	void operator ++(int){ ++*this; }
	letter_t operator * (){ return last; }
	Iter( const char *p_    ) : next( p_ ){ ++*this; }
	Iter( const NnString &s ) : next( s.chars() ){ ++*this; }
	Iter( const Iter &i     ) : last(i.last),next( i.next ){}
	int space(){ return last < 256 && isspace(last); }
	int alpha(){ return last < 256 && isalpha(last); }
	int alnum(){ return last < 256 && isalnum(last); }
	int digit(){ return last < 256 && isdigit(last); }
    };
};

/* NnString ƓAcompare/sort/uniq{̍ۂɁA啶E
 * ʂȂB*/
class NnStringIC : public NnString {
public:
    NnStringIC( const char *s ) : NnString(s){}
    NnStringIC( const NnString &ns ) : NnString(ns){}
    NnStringIC( const char *s , int size ) : NnString(s,size){}
    NnStringIC( const NnStringIC &ns ) : NnString(ns){}
    
    virtual int compare( const char *s ) const ;
    virtual int compare( const NnSortable &object ) const;
    virtual unsigned hashValue() const;
};

#endif
